Subject: bug#4841: 23.1.50; tramp su/sudo makes vc-dir hang (found remote shell ...)

From: Stefano Zacchiroli <[email-masked]>
Date: Sat, 31 Oct 2009 15:54:32 +0100

To edit system configuration files, I'd like to use tramp's su:: or
sudo::. What blocks me to do that is that I have versioned /etc (with
etckeepr over Git) and I need to commit the performed changes
afterwards.

When not inside su::/sudo:: I often commit stuff in Git repositories
using vc-mode. That unfortunately does not work under tramp's
su::/sudo::. Trying to do that results in vc-dir hanging forever just
after the "found remote shell on ..." message and the correspondent
"waiting" message in the vc buffer if I stop Emacs with C-g.

Many thanks in advance,
Cheers

In GNU Emacs 23.1.50.1 (x86_64-pc-linux-gnu, GTK+ Version 2.18.3)
 of 2009-10-23 on elegiac, modified by Debian
 (emacs-snapshot package, version 1:20091023-1)
Windowing system distributor `The X.Org Foundation', version 11.0.10605000
configured using `configure  '--build' 'x86_64-linux-gnu' '--host' 'x86_64-linux-gnu' '--prefix=/usr' '--sharedstatedir=/var/lib' '--libexecdir=/usr/lib' '--localstatedir=/var' '--infodir=/usr/share/info' '--mandir=/usr/share/man' '--with-pop=yes' '--enable-locallisppath=/etc/emacs-snapshot:/etc/emacs:/usr/local/share/emacs/23.1.50/site-lisp:/usr/local/share/emacs/site-lisp:/usr/share/emacs/23.1.50/site-lisp:/usr/share/emacs/site-lisp' '--with-x=yes' '--with-x-toolkit=gtk' 'build_alias=x86_64-linux-gnu' 'host_alias=x86_64-linux-gnu' 'CFLAGS=-DDEBIAN -DSITELOAD_PURESIZE_EXTRA=5000 -g -O2' 'LDFLAGS=-g -Wl,--as-needed' 'CPPFLAGS=''

Important settings:
  value of $LC_ALL: nil
  value of $LC_COLLATE: nil
  value of $LC_CTYPE: nil
  value of $LC_MESSAGES: en_US.UTF-8
  value of $LC_MONETARY: nil
  value of $LC_NUMERIC: nil
  value of $LC_TIME: nil
  value of $LANG: it_IT.UTF-8
  value of $XMODIFIERS: nil
  locale-coding-system: utf-8-unix
  default enable-multibyte-characters: t

Major mode: Fundamental

Minor modes in effect:
  shell-dirtrack-mode: t
  show-paren-mode: t
  tooltip-mode: t
  mouse-wheel-mode: t
  menu-bar-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  global-auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t
  column-number-mode: t
  line-number-mode: t
  transient-mark-mode: t

Recent input:
<return> <return> C-x k <return> C-x o C-x 4 0 M-x 
r e p o <tab> r t - e m <tab> <return> t r a m p SPC 
+ S-SPC s u / s u d o SPC m a k e SPC v s - s t a t 
u s SPC C-g C-h k C-x v d C-x 1 M-x <up> <return>

Recent messages:
Tramp: Waiting 60s for local shell to come up...
Tramp: Sending command `su - root && exit || exit'
Tramp: Waiting for prompts from remote shell
Tramp: Sending Password
Tramp: Found remote shell prompt on `usha.takhisis.invalid'
Quit
Making completion list...
Quit
Type C-x 1 to delete the help window.
goto-history-element: Beginning of history; no preceding item

Load-path shadows:
/usr/share/emacs/site-lisp/haskell-mode/haskell-ghci hides /usr/share/emacs/23.1.50/site-lisp/haskell-mode/haskell-ghci
/usr/share/emacs/site-lisp/haskell-mode/haskell-doc hides /usr/share/emacs/23.1.50/site-lisp/haskell-mode/haskell-doc
/usr/share/emacs/site-lisp/haskell-mode/haskell-simple-indent hides /usr/share/emacs/23.1.50/site-lisp/haskell-mode/haskell-simple-indent
/usr/share/emacs/site-lisp/haskell-mode/haskell-c hides /usr/share/emacs/23.1.50/site-lisp/haskell-mode/haskell-c
/usr/share/emacs/site-lisp/haskell-mode/haskell-mode hides /usr/share/emacs/23.1.50/site-lisp/haskell-mode/haskell-mode
/usr/share/emacs/site-lisp/haskell-mode/haskell-hugs hides /usr/share/emacs/23.1.50/site-lisp/haskell-mode/haskell-hugs
/usr/share/emacs/site-lisp/haskell-mode/haskell-cabal hides /usr/share/emacs/23.1.50/site-lisp/haskell-mode/haskell-cabal
/usr/share/emacs/site-lisp/haskell-mode/haskell-decl-scan hides /usr/share/emacs/23.1.50/site-lisp/haskell-mode/haskell-decl-scan
/usr/share/emacs/site-lisp/haskell-mode/inf-haskell hides /usr/share/emacs/23.1.50/site-lisp/haskell-mode/inf-haskell
/usr/share/emacs/site-lisp/haskell-mode/haskell-indent hides /usr/share/emacs/23.1.50/site-lisp/haskell-mode/haskell-indent
/usr/share/emacs/site-lisp/haskell-mode/haskell-font-lock hides /usr/share/emacs/23.1.50/site-lisp/haskell-mode/haskell-font-lock
/usr/share/emacs/23.1.50/site-lisp/debian-startup hides /usr/share/emacs/site-lisp/debian-startup
/usr/share/emacs/site-lisp/rst hides /usr/share/emacs/23.1.50/lisp/textmodes/rst

Features:
(shadow mail-extr emacsbug help-mode view org-wl org-w3m org-vm
org-rmail org-mhe org-mew org-irc org-jsinfo org-infojs org-html org-exp
org-exp-blocks org-agenda org-info org-gnus org-bibtex org-bbdb vc-git
vc-bzr vc-sccs vc-svn vc-cvs vc-rcs tramp-imap epa epg epg-config
imap-hash imap message sendmail ecomplete rfc822 mml mml-sec mm-decode
mm-bodies mm-encode mailcap mail-parse rfc2231 rfc2047 rfc2045 qp
ietf-drums mailabbrev nnheader mm-util mail-prsvr gmm-utils wid-edit
mailheader canlock sha1 hex-util hashcash mail-utils assoc tramp-gw
tramp-fish tramp-smb tramp-cache tramp-ftp tramp-cmds tramp auth-source
gnus-util netrc shell comint password-cache format-spec tramp-compat
trampver vc-dir ewoc vc vc-dispatcher org-protocol remember org-remember
org byte-opt bytecomp byte-compile org-footnote org-src org-list
org-faces org-compat org-macs time-date noutline outline easy-mmode
regexp-opt post easymenu derived cl cl-19 rect-mark server windmove
winner ido paren cus-start cus-load viper edmacro kmacro viper-ex
viper-macs viper-mous viper-cmd viper-keym ring viper-util viper-init
advice help-fns advice-preload debian-el debian-el-loaddefs
emacs-goodies-el emacs-goodies-custom emacs-goodies-loaddefs dpkg-dev-el
dpkg-dev-el-loaddefs tooltip ediff-hook vc-hooks lisp-float-type mwheel
x-win x-dnd tool-bar dnd fontset image fringe lisp-mode register page
menu-bar rfn-eshadow timer select scroll-bar mldrag mouse jit-lock
font-lock syntax facemenu font-core frame cham georgian utf-8-lang
misc-lang vietnamese tibetan thai tai-viet lao korean japanese hebrew
greek romanian slovak czech european ethiopic indian cyrillic chinese
case-table epa-hook jka-cmpr-hook help simple abbrev loaddefs button
minibuffer faces cus-face text-properties overlay md5 base64 format env
code-pages mule custom widget hashtable-print-readable backquote
make-network-process dbusbind gtk x-toolkit x multi-tty emacs)

-- 
Stefano Zacchiroli -o- PhD in Computer Science \ PostDoc @ Univ. Paris 7
zack@{upsilon.cc,pps.jussieu.fr,debian.org} -<>- http://upsilon.cc/zack/
Dietro un grande uomo c'è ..|  .  |. Et ne m'en veux pas si je te tutoie
sempre uno zaino ...........| ..: |.... Je dis tu à tous ceux que j'aime